package org.example;

import java.util.LinkedList;

public class DoubleTree {

    public static void main(String[] args) {

        DoubleTree.Node root = new DoubleTree.Node(2);
        DoubleTree.Node temp = null;
        temp = new DoubleTree.Node(4);
        root.left = temp;
        temp = new DoubleTree.Node(6);
        root.right = temp;
        temp = new DoubleTree.Node(8);
        root.left.left = temp;
        temp = new DoubleTree.Node(10);
        root.left.right = temp;
        temp = new DoubleTree.Node(12);
        root.right.left = temp;
        temp = new DoubleTree.Node(14);
        root.right.right = temp;
        temp = new DoubleTree.Node(16);
        root.left.left.left = temp;
        temp = new DoubleTree.Node(18);
        root.left.left.right = temp;
        temp = new DoubleTree.Node(20);
        root.left.right.left = temp;
        temp = new DoubleTree.Node(22);
        root.left.right.right = temp;
        temp = new DoubleTree.Node(24);
        root.right.left.left = temp;
        temp = new DoubleTree.Node(26);
        root.right.left.right = temp;
        temp = new DoubleTree.Node(28);
        root.right.right.left = temp;
        temp = new DoubleTree.Node(30);
        root.right.right.right = temp;

        printBinaryTree(root);

    }

    public static class Node {

        public Node(int data) {
            this.data = data;
        }

        int data;
        Node left;
        Node right;
    }
    public static void printBinaryTree(Node root) {
        LinkedList<Node> treeLevel1 = new LinkedList<Node>();
        treeLevel1.add(root);
        LinkedList<Node> temp = new LinkedList<Node>();
        int counter = 0;
        int height = heightOfTree(root) - 1;
        //System.out.println(height);
        double numberOfElements = (Math.pow(2,(height + 1)) - 1) ;
        //System.out.println(numberOfElements);
        while (counter <= height) {
            Node removed = treeLevel1.removeFirst();
            if (temp.isEmpty()) {
                printSpace(numberOfElements / Math.pow(2, counter + 1), removed);
            } else {
                printSpace(numberOfElements / Math.pow(2, counter), removed);
            }
            if (removed == null) {
                temp.add(null);
                temp.add(null);
            } else {
                temp.add(removed.left);
                temp.add(removed.right);
            }
            if (treeLevel1.isEmpty()) {
                System.out.println("");
                System.out.println("");
                treeLevel1 = temp;
                temp = new LinkedList<>();
                counter++;
            }
        }

    }
    public static void printSpace(double n, Node removed) {
        for (; n > 0; n--) {
            System.out.print("\t");
        }
        if (removed == null) {
            System.out.print(" ");
        }
        else {
            System.out.print(removed.data);
        }
    }
    public static int heightOfTree(Node root) {
        if (root == null) {
            return 0;
        }
        return 1 +
                Math.max(heightOfTree(root.left),
                        heightOfTree(root.right));
    }
}
